#ifndef DBC_h
#define DBC_h

#include <System/FatalAlert.h>

#ifdef DBC

#define REQUIRE(C) ((void)(C?0:ErrDisplayFileLineMsg(__FILE__,__LINE__,__PRETTY_FUNCTION__ ## ": REQUIRE VIOLATED: " ## #C)))

#define CHECK(C) ((void)(C?0:ErrDisplayFileLineMsg(__FILE__,__LINE__,__PRETTY_FUNCTION__ ## ": CHECK VIOLATED: " ## #C)))

#define ENSURE(C) ((void)(C?0:ErrDisplayFileLineMsg(__FILE__,__LINE__,__PRETTY_FUNCTION__ ## ": ENSURE VIOLATED: " ## #C)))

#else /* if ! DBC */

#define REQUIRE(C) ((void)0)

#define ENSURE(C) ((void)0)

#define CHECK(C) ((void)0)

#endif /*DBC */

#endif /* DBC_h */
